/* Prototypes */
#include <clib/locale_protos.h>
#include <clib/dos_protos.h>

/* Pragmas */
#ifdef AZTEC_C
#include <pragmas/locale_lib.h>
#endif /*   AZTEC_C		    */

#if defined(__SASC)  ||  defined(_DCC)  ||  defined(__MAXON__)
#include <pragma/locale_lib.h>     
#endif	/*  __SASC  ||	_DCC  ||  __MAXON__	*/

#ifdef __GNUC__
#include <inline/locale.h>
#endif	/*  __GNUC__	*/

static LONG fax_Version = 0;
static const STRPTR fax_BuiltInLanguage = (STRPTR) "english";

struct FC_Type
{   LONG   ID;
    char *Str;
};

/* Definitions */
const struct FC_Type _MSG_AppDescription = { 0, "Desk for Multifax 4.0  by TKR" };
const struct FC_Type _MSG_AppCopyright = { 1, " by Jrgen Spth" };
const struct FC_Type _MSG_Fax_Win = { 2, "MultiFax V 1.9  1996 J. Spth" };
const struct FC_Type _MSG_MNlabel1Projekt = { 3, "Project" };
const struct FC_Type _MSG_MNlabel1ber = { 4, "About" };
const struct FC_Type _MSG_MNlabel1berChar = { 5, "a_" };
const struct FC_Type _MSG_MNlabel1Beenden = { 6, "Quit" };
const struct FC_Type _MSG_MNlabel1BeendenChar = { 7, "q_" };
const struct FC_Type _MSG_BT_Printer = { 8, "_Printer-Server" };
const struct FC_Type _MSG_BT_Spooler = { 9, "_Fax-Spooler" };
const struct FC_Type _MSG_BT_Logbook = { 10, "_Logbook" };
const struct FC_Type _MSG_BT_Config = { 11, "_Configuration" };
const struct FC_Type _MSG_BT_Desktop = { 12, "De_sk" };
const struct FC_Type _MSG_BT_Phone = { 13, "E_dit Phone" };
const struct FC_Type _MSG_BT_View = { 14, "_View" };
const struct FC_Type _MSG_BT_End = { 15, "_End" };
const struct FC_Type _MSG_Info_Win = { 16, "Info" };
const struct FC_Type _MSG_TX_ueber = { 17, "\nThe ultimative\n\nMulti-Fax-Desk\n\n\0330 \033b by Jrgen Spth\n\n\033nCompiled with MAXON\n\n at 27.April 1996\n\nMUI  by Stefan Stuntz\n\033b&\n\033n  MUI-Builder  by Eric Totel  \n" };
const struct FC_Type _MSG_BT_OK = { 18, "_OK" };
static struct Catalog *fax_Catalog = NULL;

void OpenAppCatalog(struct Locale *loc, STRPTR language)
{
	LONG tag, tagarg;
	extern struct Library *LocaleBase;
	extern void CloseAppCatalog(void);

	CloseAppCatalog(); /* Not needed if the programmer pairs OpenAppCatalog
			and CloseAppCatalog right, but does no harm.  */

	if (LocaleBase != NULL  &&  fax_Catalog == NULL)
	{
	if (language == NULL)
		tag = TAG_IGNORE;
	else
	{
		tag = OC_Language;
		tagarg = (LONG) language;
	}
	fax_Catalog = OpenCatalog(loc, (STRPTR) "fax.catalog",
			OC_BuiltInLanguage, fax_BuiltInLanguage,
			tag, tagarg,
			OC_Version, fax_Version,
			TAG_DONE);
	}
}

void CloseAppCatalog(void)
{
	if (LocaleBase)        
		CloseCatalog(fax_Catalog);
	fax_Catalog = NULL;
}

char * GetFaxString(APTR fcstr)
{
	char *defaultstr;
	LONG strnum;

	strnum = ((struct FC_Type *) fcstr)->ID;
	defaultstr = ((struct FC_Type *) fcstr)->Str;

	return(fax_Catalog ? (char *)GetCatalogStr(fax_Catalog, strnum, defaultstr) :
			defaultstr);
}
